#include <sourcemod>
#include <sdktools>
#include "sdkhooks.inc"

#define VERSION "pre1.0.0"
#define DEBUG 0

public Plugin:myinfo = 
{
	name = "L4D AntiRunTrap",
	author = "ArmGadge",
	description = "Lock the saferoom entrance door until all survivors coming",
	version = VERSION,
	url = "http://radiowave.moe.hm/"
};

new bool:trigger_rs = false;
new bool:doorlocked = false;
new bool:entrancedoorfound = false;
new bool:trigger_ci = false;

new ent_cpd_finish;
new Float:cpdoororigin[3];
new alivetankcount;
new Float:cpd_speed;

//cvar
new Handle:h_cv_survivorlimit_tank;
new Handle:h_cv_survivorlimit_dist;
new Handle:h_cv_passive_dist;
new Handle:h_cv_passive_boomer;

new String:mapname[128];

//ars2 statics
new waitingtime[MAXPLAYERS+1];
new Float:spawnpoint[10][3];
new Float:spawnpos_pasv[8][3];
new bool:memory_first = true;

//ars2cvar
new Handle:h_cv_aggressive_dist;
new Handle:h_cv_aggressive_time;
new Handle:h_cv_aggressive_polling;
new Handle:h_cv_invisi_si;
new Handle:h_cv_aggressive_def;
new Handle:h_cv_humanonly;
new Handle:h_cv_edit;

new bool:activate_ars2 = false;
new bool:activate_ars2_sispawn = false;
new bool:issomeonewaiting = false;
new Handle:h_OffsidePollTimer = INVALID_HANDLE;
new Handle:h_timer_popcitick = INVALID_HANDLE;
new Handle:h_AutoLockTimer = INVALID_HANDLE;
new Handle:h_timer_initteleport = INVALID_HANDLE;
new Handle:h_timer_invisi_si[MAXPLAYERS+1] = INVALID_HANDLE;
new Handle:h_timer_alartsound = INVALID_HANDLE;
new Handle:h_timer_prealartsound = INVALID_HANDLE;
new Handle:h_timer_announcemsg[MAXPLAYERS+1] = INVALID_HANDLE;

new waitingtime_longest;
new g_agr_prealart_time;
new opmode;
new mode_aggressive;
new Float:cpddetectpos[3];
new Float:range_z;
new boomerbombticket;

new String:logpath[PLATFORM_MAX_PATH];
new String:pmcpath[PLATFORM_MAX_PATH];
new count_cipop;



public OnPluginStart()
{
	// Require Left 4 Dead (2)
	decl String:game_name[64];
	GetGameFolderName(game_name, sizeof(game_name));
	if (!StrEqual(game_name, "left4dead", false) 
		&& !StrEqual(game_name, "left4dead2", false))
	{
		SetFailState("Plugin supports Left 4 Dead or Left 4 Dead 2 only.");
	}	
	
	RegAdminCmd("l4d_antirun_lock", Command_EntLock, ADMFLAG_GENERIC, "set door lock");
	RegAdminCmd("l4d_antirun_unlock", Command_EntUnlock, ADMFLAG_GENERIC, "set door unlock");
	RegAdminCmd("l4d_antirun_forceaggressive", Command_ForceArs2, ADMFLAG_CONVARS, "ars2forceactivate");
	RegAdminCmd("l4d_antirun_command2", Command_EntCmd2, ADMFLAG_CONVARS, "set door unlock");
	RegAdminCmd("l4d_antirun_setid", Command_ForceSetId, ADMFLAG_CONVARS, "set entity ID to control door mandatory.");
	RegAdminCmd("l4d_antirun_status", Command_PluginStatus, ADMFLAG_GENERIC, "show plugin status.");
	RegAdminCmd("l4d_antirun_boomerbomb", PerformBoomerBomb, ADMFLAG_CONVARS, "perform boomer bomb (for testing).");
	RegAdminCmd("l4d_antirun_edit_save", Command_SaveSettings, ADMFLAG_CONVARS, "Write detect position to per-map config file.");
	RegAdminCmd("l4d_antirun_edit_erasepos", Command_ErasePosition, ADMFLAG_CONVARS, "Erase detect position from per-map config file.");
	RegAdminCmd("l4d_antirun_edit_setdetectpos", Command_SetDetectPos, ADMFLAG_CONVARS, "Set detect position.");
	RegAdminCmd("l4d_antirun_edit_setval", Command_SetValue, ADMFLAG_CONVARS, "Set per-map config values.");
	RegAdminCmd("l4d_antirun_edit_chkdist", Command_CheckDistance, ADMFLAG_CONVARS, "Check distance from door to player.");
	RegAdminCmd("l4d_antirun_edit_reload", Command_ReloadConfig, ADMFLAG_CONVARS, "Reload settings from per-map config file.");
	RegAdminCmd("l4d_antirun_edit_show", Command_ShowConfig, ADMFLAG_CONVARS, "Show current per-map config.");
	
	CreateConVar("l4d_antirun_version", VERSION, "Version of AntiRunTrap Plugin", FCVAR_REPLICATED|FCVAR_NOTIFY|FCVAR_DONTRECORD);
	h_cv_survivorlimit_tank = CreateConVar("l4d_antirun_survivorlimit_tank", "0",
		"if alive survivors less than or equal this threshold, the tank coundition make clear whether or not tanks spawning ");
	h_cv_survivorlimit_dist = CreateConVar("l4d_antirun_survivorlimit_dist", "0",
		"if alive survivors less than or equal this threshold, the distance coundition make clear");
	h_cv_passive_dist = CreateConVar("l4d_antirun_dist", "30", "threshold of distance condition [meters](int)");
	h_cv_passive_boomer = CreateConVar("l4d_antirun_boomer", "1", "let the player eat Boomer-bomb when conditons are not satisfied (0|1)");
	h_cv_aggressive_dist = CreateConVar("l4d_antirun_aggressive_dist", "30",
		"plugin will judge that player is waiting when player stay within this distance(player-to-safedoor) [meters](int)");
	h_cv_aggressive_time = CreateConVar("l4d_antirun_aggressive_time", "30",
		"plugin will judge that player is waiting when player stay this duration [sec](int)");
	h_cv_aggressive_polling = CreateConVar("l4d_antirun_aggressive_polling", "5",
		"plugin will polling players this interval [sec](int)");
	h_cv_invisi_si = CreateConVar("l4d_antirun_aggressive_invisi", "0",
		"when aggressive mode, make special infected invisible. (0|1)", _, true, 0.0, true, 1.0);
	h_cv_aggressive_def = CreateConVar("l4d_antirun_aggressive_def", "1",
		"default aggressive mode (0|1)", _, true, 0.0, true, 1.0);
	h_cv_humanonly = CreateConVar("l4d_antirun_eval_dist_humanonly", "1",
		"Only evaluate human players when judging player distance (0|1)", _, true, 0.0, true, 1.0);
	h_cv_edit = CreateConVar("l4d_antirun_edit", "0",
		"Enable edit mode (0|1)", FCVAR_DONTRECORD, true, 0.0, true, 1.0);
	
	HookConVarChange(h_cv_edit, OnSwitchedEditMode);
	
	HookEvent("round_start", Event_RoundStart);
	HookEvent("round_end", Event_RoundEnd);
	HookEvent("player_use", Event_PlayerUse);
	HookEvent("player_spawn", Event_PlayerSpawn);
	HookEvent("player_death", Event_PlayerDeath);
	//HookEvent("tank_spawn", Event_TankSpawn);
	//HookEvent("tank_killed", Event_TankKilled);

	BuildPath(Path_SM, logpath, sizeof(logpath), "logs/l4d_antiruntrap.log");
	BuildPath(Path_SM, pmcpath, sizeof(pmcpath), "configs/l4d_antiruntrap/pmc.txt");
	
	AutoExecConfig(true, "l4d_antiruntrap");
	
	LoadTranslations("plugin.l4d_antiruntrap");
	
	InitPlugin();
	if (IsValidGameMode()) LoadPerMapConfig();
	if (IsValidEntity(ent_cpd_finish))
		h_AutoLockTimer = CreateTimer(30.0, AutoDoorLock);
}

public OnPluginEnd()
{
	ChangeDoorLockState(ent_cpd_finish, false);
}

public OnMapStart()
{
	PrecacheSound("buttons/bell1.wav", true);
	PrecacheSound("buttons/blip1.wav", true);
	PrecacheSound("ambient/alarms/klaxon1.wav", true);
	trigger_rs = false;
}

public OnMapEnd()
{
	DisableAggressiveMode();
}

public OnClientPutInServer(client)
{
	if (ent_cpd_finish >= 0 && IsFakeClient(client) == false)
	{
		h_timer_announcemsg[client] = CreateTimer(30.0, AnnounceMsg, client);
	}
}

public Action:AnnounceMsg(Handle:timer, any:client)
{
	PrintToChat(client, "\x03[AntiRunTrap] %t", "saferoom_locked");
	h_timer_announcemsg[client] = INVALID_HANDLE;
}

public OnClientDisconnect(client)
{
	if(h_timer_invisi_si[client] != INVALID_HANDLE)
	{
#if DEBUG
		LogToFile(logpath, "(Disconnect) Releaseing invisi si timer handle for client %d.", client);
#endif
		KillTimer(h_timer_invisi_si[client]);
		h_timer_invisi_si[client] = INVALID_HANDLE;
	}
	
	if (h_timer_announcemsg[client] != INVALID_HANDLE)
	{
		KillTimer(h_timer_announcemsg[client]);
		h_timer_announcemsg[client] = INVALID_HANDLE;
	}
}

public Event_RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	InitPlugin();
	if (IsValidGameMode()) LoadPerMapConfig();
	if (IsValidEntity(ent_cpd_finish))
		h_AutoLockTimer = CreateTimer(30.0, AutoDoorLock);
}

public Event_RoundEnd(Handle:event, const String:name[], bool:dontBroadcast)
{
	DisableAggressiveMode();
}

public OnSwitchedEditMode(Handle:cvar, const String:oldval[], const String:newval[])
{
	DisableAggressiveMode();
	if (doorlocked == true) ChangeDoorLockState(ent_cpd_finish, false);
	InitPlugin();
	if (IsValidGameMode()) LoadPerMapConfig();
	if (StrEqual(newval, "0") && IsValidEntity(ent_cpd_finish))
	{	
		h_AutoLockTimer = CreateTimer(1.0, AutoDoorLock);
	}
}

InitPlugin()
{
#if DEBUG
	LogToFile(logpath, "----- Plugin Init -----");
#endif	
	DisableAggressiveMode();
	if(h_AutoLockTimer != INVALID_HANDLE)
	{
		KillTimer(h_AutoLockTimer);
		h_AutoLockTimer = INVALID_HANDLE;
	}
	
	for (new i=1; i<=MaxClients; i++)
	{
		if(h_timer_invisi_si[i] != INVALID_HANDLE)
		{
			KillTimer(h_timer_invisi_si[i]);
			h_timer_invisi_si[i] = INVALID_HANDLE;
		}
		if (h_timer_announcemsg[i] != INVALID_HANDLE)
		{
			KillTimer(h_timer_announcemsg[i]);
			h_timer_announcemsg[i] = INVALID_HANDLE;
		}
		waitingtime[i] = -1;
	}

	if(h_timer_initteleport != INVALID_HANDLE)
	{
		KillTimer(h_timer_initteleport);
		h_timer_initteleport = INVALID_HANDLE;
	}
	
	//alivetankcount = 0;
	entrancedoorfound = false;
	doorlocked = false;
	count_cipop = 0;
	//ars2
	issomeonewaiting = false;
	memory_first = true;
	
	//pmc
	ent_cpd_finish = -1;
	opmode = 1;
	mode_aggressive = GetConVarInt(h_cv_aggressive_def);
	range_z = 0.0;
	
	g_agr_prealart_time = 0;

/*
	decl String:gamemode[64];		
	GetConVarString(FindConVar("mp_gamemode"), gamemode, sizeof(gamemode));		
	if (StrEqual(gamemode, "coop", false) ||
		StrEqual(gamemode, "realism", false))
	{
		GetCurrentMap(mapname, sizeof(mapname));
		#if DEBUG
		LogToFile(logpath, "Detected coop mode, starting up. mapname=%s", mapname);
		#endif
		
		LoadPerMapConfig();
		if (IsValidEntity(ent_cpd_finish))
			h_AutoLockTimer = CreateTimer(60.0, AutoDoorLock);
	}
	else
	{
		#if DEBUG
		LogToFile(logpath, "Gamemode is not coop, standing by.");
		#endif	
	}
*/
}

bool:IsValidGameMode()
{
	decl String:gamemode[64];		
	GetConVarString(FindConVar("mp_gamemode"), gamemode, sizeof(gamemode));		
	if (StrEqual(gamemode, "coop", false) ||
		StrEqual(gamemode, "realism", false))
	{
		GetCurrentMap(mapname, sizeof(mapname));
#if DEBUG
		LogToFile(logpath, "Detected coop mode, starting up. mapname=%s", mapname);
#endif
		return true;

	}
	else
	{
#if DEBUG
		LogToFile(logpath, "Gamemode is not coop, standing by.");
#endif	
		return false;
	}
}

public Action:ReturnTriggerRS(Handle:timer)
{
	trigger_rs = false;
}

public Action:ReturnTriggerCI(Handle:timer)
{
	trigger_ci = false;
}
/*
public Event_TankSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	alivetankcount++;
}

public Event_TankKilled(Handle:event, const String:name[], bool:dontBroadcast)
{
	alivetankcount--;
}
*/
public Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new userid = GetEventInt(event, "userid");
	new client = GetClientOfUserId(userid);
	
	if (GetClientTeam(client) == 3)
	{
		if (boomerbombticket == 1)
		{
			SetEntityRenderMode(client, RENDER_NONE);
			ForcePlayerSuicide(client);
			boomerbombticket = 0;
		}
		else if (activate_ars2_sispawn == true &&
			memory_first == false &&
			issomeonewaiting == true)
		{
			new randomnum = GetRandomInt(0, 9);
			TeleportEntity(client, spawnpoint[randomnum], NULL_VECTOR, NULL_VECTOR);
			if (GetConVarBool(h_cv_invisi_si))
			{
				SetEntityRenderMode(client, RENDER_NONE);
#if DEBUG
				LogToFile(logpath, "(PlayerSpawn) Leaseing invisi si timer handle for client %d.", client);
#endif
				h_timer_invisi_si[client] = CreateTimer(60.0, KillInvisiSI, client);
			}
			//SetEntityRenderColor(client, 255, 255, 255, 0);
		}
	}
}

public OnEntityCreated(entity, const String:classname[])
{
	if (StrEqual(classname, "infected") && ((trigger_ci) ||
		(activate_ars2 && issomeonewaiting)))
		SDKHook(entity, SDKHook_Spawn, OnCISpawned);
}

public OnCISpawned(entity)
{
	new randomnum;
	if (trigger_ci)
	{
		randomnum = GetRandomInt(0, 7);
		TeleportEntity(entity, spawnpos_pasv[randomnum], NULL_VECTOR, NULL_VECTOR);
	}
	else
	{
		randomnum = GetRandomInt(0, 9);
		TeleportEntity(entity, spawnpoint[randomnum], NULL_VECTOR, NULL_VECTOR);
	}
}

public Event_PlayerUse(Handle:event, const String:name[], bool:dontBroadcast)
{
	new userid = GetEventInt(event, "userid");
	new client = GetClientOfUserId(userid);
	decl String:username[255];
	GetClientName(client, username, sizeof(username));
	new targetid = GetEventInt(event, "targetid");
	new bool:clear_tank, bool:clear_dist;
	//PrintToChatAll("cid %d touched-> %d",client, targetid);
	new Float:dist, Float:dist_m, Float:dist_farest;
	new Float:z_dist, Float:z_dist_largest;
	new Float:pos_leader[3], Float:pos_client[3];

	if (doorlocked && targetid == ent_cpd_finish)
	{
		//condition tank
		if (AliveTankCount() == 0 || AliveSurvivorCount() <= GetConVarInt(h_cv_survivorlimit_tank))
		{
			//PrintToChat(client, "Tank Cleared.");
			clear_tank = true;
		}
		
		
		//condition dist
		//leaderdist = GetDistanceLeaderToOthers(client);
		if (AliveSurvivorCount() <= GetConVarInt(h_cv_survivorlimit_dist))
			clear_dist = true;
		else
		{
			GetClientAbsOrigin(client, pos_leader);
			for(new i=1; i<=MaxClients; i++)
			{
				if((i != client) &&
					IsClientInGame(i) &&
					(GetClientTeam(i) == 2)	&&
					IsPlayerAlive(i))
				{
					if (GetConVarInt(h_cv_humanonly) == 0 ||
						(GetConVarInt(h_cv_humanonly) == 1 && !IsFakeClient(i))) 
					{
						//get distance leader - player
						GetClientAbsOrigin(i, pos_client);
						dist = GetVectorDistance(pos_leader, pos_client);
						dist_m = dist*0.01905;
						z_dist = FloatAbs(pos_leader[2] - pos_client[2]);
						//PrintToChatAll("leader - i: %f (%f meters)", intdist, distinm);
						//search farest dist (largest dist)
						if (dist_m > dist_farest) dist_farest = dist_m;
						if (z_dist > z_dist_largest) z_dist_largest = z_dist;
					}
				}
			}
			//PrintToChatAll("Distance leader to farest = %f m", leaderdist);
#if DEBUG
			LogToFile(logpath, "Tank count: %d", AliveTankCount());
			LogToFile(logpath, "Survivor count: %d", AliveSurvivorCount());
			LogToFile(logpath, "dist_farest: %f (limit: %f)",
				dist_farest, float(GetConVarInt(h_cv_passive_dist)));
			LogToFile(logpath, "z_dist_largest: %f (limit: %f)",
				z_dist_largest, range_z);
#endif			
			if(dist_farest <= float(GetConVarInt(h_cv_passive_dist)) &&
				(range_z <= 0.0 || 
				z_dist_largest <= range_z))
			{
				//PrintToChat(client, "Distance Cleared.");
				clear_dist = true;
			}
		}
		
		if (clear_tank && clear_dist)
		{
			DisableAggressiveMode();
			ChangeDoorLockState(ent_cpd_finish, false);
			EmitSoundToAll("buttons/bell1.wav",
				ent_cpd_finish,
				SNDCHAN_AUTO,
				SNDLEVEL_GUNFIRE
			);
			
			PrintHintText(client, "%t", "you_unlocked");
			PrintToChatAll("\x03[AntiRunTrap] %t", "player_unlocked", username);
			PrintToServer("%s unlocked the door.", username);	
#if DEBUG
			LogToFile(logpath, "unlock successful.");
#endif
		}
		else 
		{
			if(GetConVarBool(h_cv_passive_boomer) == true)
			{
				PerformBoomerBomb(client, '\0');
				//new Float:vec[3] = {360.0, 360.0, 360.0};
				//SetEntPropVector(client, Prop_Send, "m_angRotation", vec);
			}
			PrintToChatAll("\x04[AntiRunTrap] %t", "player_failedunlock", username);
			PrintToServer("%s failed to unlock the door.", username);
#if DEBUG
			LogToFile(logpath, "unlock failed.");
#endif
			if (!clear_tank) PrintHintText(client, "%t", "cantopen_tank");
			else PrintHintText(client, "%t", "cantopen_toofar", RoundFloat(dist_farest));
		}
	}
}

public Event_PlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	new userid = GetEventInt(event, "userid");
	new client = GetClientOfUserId(userid);
	
	if(h_timer_invisi_si[client] != INVALID_HANDLE)
	{
#if DEBUG
		LogToFile(logpath, "(Event_PlayerDeath) Releaseing invisi si timer handle for client %d.", client);
#endif
		KillTimer(h_timer_invisi_si[client]);
		h_timer_invisi_si[client] = INVALID_HANDLE;
	}
}

public Action:OffsideCheck(Handle:timer)
{
	new Float:clientorg[3];
	new Float:dist_player_door, Float:dist_player_door_inm;
	new cid_nearest;
	new Float:dist_nearest_client;
	new Float:origin_nearest_client[3];
	issomeonewaiting = false;
	
	origin_nearest_client = cpdoororigin;
	waitingtime_longest = -1;
	//wating time count
	for(new i=1; i<=MaxClients; i++)
	{
		if(IsClientInGame(i) && (GetClientTeam(i) == 2) && IsPlayerAlive(i))
		{
			if (GetConVarInt(h_cv_humanonly) == 0 ||
				(GetConVarInt(h_cv_humanonly) == 1 && !IsFakeClient(i))) 
			{
				GetClientAbsOrigin(i, clientorg);
				dist_player_door = GetVectorDistance(cpdoororigin, clientorg);
				dist_player_door_inm = dist_player_door*0.01905;
				
				if (cid_nearest == 0 || dist_player_door < dist_nearest_client)
				{
					cid_nearest = i;
					dist_nearest_client = dist_player_door;
					origin_nearest_client = clientorg;
				}

				//PrintToServer("client%d to door: %f",i,dist_player_door_inm);
				if (dist_player_door_inm <= float(GetConVarInt(h_cv_aggressive_dist)) &&
					(range_z <= 0.0 || FloatAbs(cpdoororigin[2] - (origin_nearest_client[2] + 50.0)) <= range_z))
				{
					issomeonewaiting = true;
					if (waitingtime[i] == -1) waitingtime[i] = 0;
					else waitingtime[i] += GetConVarInt(h_cv_aggressive_polling);
					#if DEBUG
					PrintToServer("waiting[%d]: %d", i, waitingtime[i]);
					#endif
					if (waitingtime_longest < waitingtime[i])
					{
						waitingtime_longest = waitingtime[i];
					}
				}
				else waitingtime[i] = -1;
				

			}
			else if (waitingtime[i] > 0) waitingtime[i] = -1;
		}
		else if (waitingtime[i] > 0) waitingtime[i] = -1;
	}
	
	if(activate_ars2 == false)
	{
		if (waitingtime_longest < 0)
		{
			if (h_timer_prealartsound != INVALID_HANDLE)
			{
				KillTimer(h_timer_prealartsound)
				h_timer_prealartsound = INVALID_HANDLE;
			}
		}
		else if (waitingtime_longest >= 0 &&
			waitingtime_longest < GetConVarInt(h_cv_aggressive_time))
		{
			g_agr_prealart_time = waitingtime_longest;
			if (h_timer_prealartsound == INVALID_HANDLE)
				h_timer_prealartsound = CreateTimer(1.0, SoundPreAlart, _, TIMER_REPEAT);
		}
		else if (waitingtime_longest >= GetConVarInt(h_cv_aggressive_time))
		{
			activate_ars2 = true;
			#if DEBUG
			PrintToServer("*** Activating aggressive-mode ***");
			#endif
			if (h_timer_prealartsound != INVALID_HANDLE)
			{
				KillTimer(h_timer_prealartsound)
				h_timer_prealartsound = INVALID_HANDLE;
			}
		}
		
	}	
	//spawn position memory
	if(activate_ars2 && issomeonewaiting)
	{
		if (memory_first)
		{
			memory_first = false;
			for (new i=0; i<10; i++) spawnpoint[i] = origin_nearest_client;
			h_timer_alartsound = CreateTimer(1.0, SoundAlart, _, TIMER_REPEAT);
			InitTeleport();
			PrintToChatAll("\x04[AntiRunTrap] %t", "teleport_activate");
		}
		else
		{
			//shift array up
			for (new i=9; i>0; i--) spawnpoint[i] = spawnpoint[i-1];
			spawnpoint[0] = origin_nearest_client;
		}
	}
}

InitTeleport()
{
	new bool:invisi_si = GetConVarBool(h_cv_invisi_si);
	for(new i=1; i<=MaxClients; i++)
	{
		if(IsClientInGame(i) && (GetClientTeam(i) == 3) && IsPlayerAlive(i))
		{
			TeleportEntity(i, spawnpoint[0], NULL_VECTOR, NULL_VECTOR);
			if (invisi_si == true)
			{
				if(h_timer_invisi_si[i] == INVALID_HANDLE)
				{
#if DEBUG
					LogToFile(logpath, "(InitTeleport) Leaseing invisi si timer handle for client %d.", i);
#endif
					SetEntityRenderMode(i, RENDER_NONE);
					h_timer_invisi_si[i] = CreateTimer(60.0, KillInvisiSI, i);
				}
			}
		}
	}
	activate_ars2_sispawn = true;
	
	//h_timer_initteleport = INVALID_HANDLE;
	
	//h_timer_popcitick = CreateTimer(float(GetConVarInt(interval_infected)), TeleportCI, _, TIMER_REPEAT);
}

public Action:KillInvisiSI(Handle:timer, any:client)
{
	//don't have to release the timer handle on here, because this will trigger player_death event
	ForcePlayerSuicide(client);
}
		
public Action:SoundAlart(Handle:timer)
{
	EmitSoundToAll("ambient/alarms/klaxon1.wav",
		ent_cpd_finish,
		SNDCHAN_AUTO,
		SNDLEVEL_GUNFIRE
	);
	return Plugin_Continue;
}

public Action:SoundPreAlart(Handle:timer)
{
/*
	static wt_sndtick;
	new prealartpitch;
	if (wt_sndtick - waitingtime_longest >= GetConVarInt(h_cv_aggressive_polling))
	{
		wt_sndtick = waitingtime_longest;
	}
	else
	{
		wt_sndtick++;
	}
	prealartpitch = 
		RoundFloat(100.0 + (float(wt_sndtick) / float(GetConVarInt(h_cv_aggressive_time))) * 100.0);
	
	PrintToServer("wt_sndtick %d/ pitch %d", wt_sndtick, prealartpitch);
	EmitSoundToAll("buttons/blip1.wav",
		ent_cpd_finish,
		SNDCHAN_AUTO,
		SNDLEVEL_GUNFIRE,
		SND_CHANGEPITCH,
		SNDVOL_NORMAL,
		prealartpitch
	);
	
*/

	new prealartpitch = 
		RoundFloat(100.0 + (float(g_agr_prealart_time) / float(GetConVarInt(h_cv_aggressive_time))) * 100.0);
#if DEBUG
	PrintToServer("preal %d/ pitch %d", g_agr_prealart_time, prealartpitch);
#endif
	EmitSoundToAll("buttons/blip1.wav",
		ent_cpd_finish,
		SNDCHAN_AUTO,
		SNDLEVEL_GUNFIRE,
		SND_CHANGEPITCH,
		SNDVOL_NORMAL,
		prealartpitch
	);
	g_agr_prealart_time++;
	
	return Plugin_Continue;
}

AliveSurvivorCount()
{
	new count;
	for(new i=1; i<=MaxClients; i++)
	{
		if(IsClientInGame(i) && (GetClientTeam(i) == 2) && IsPlayerAlive(i))
			count++;
	}
	return count;
}

AliveTankCount()
{
	new count;
	decl String:classname[32];
	for (new i=1; i<=MaxClients; i++)
	{
		if (IsClientInGame(i) && (GetClientTeam(i) == 3) && IsPlayerAlive(i))
		{
			GetEntityNetClass(i, classname, sizeof(classname));
			if (StrEqual(classname, "Tank")) count++;
		}
	}
	return count;
}

LoadPerMapConfig()
{
	//init

	decl String:strbuf_detectpos[64];
	decl String:strbuf_detectpos_exp[3][16];
	strcopy(strbuf_detectpos, sizeof(strbuf_detectpos), "0.0,0.0,0.0");
	//entrancedoorfound = false;
	
	new Handle:kv = CreateKeyValues("PerMapConfig");
	
	//Load settings per map
	if (FileToKeyValues(kv, pmcpath))
	{
		if (KvJumpToKey(kv, mapname))
		{
			opmode = KvGetNum(kv, "OperationMode", 1);
			KvGetString(kv, "CPDoorDetectPos", strbuf_detectpos,
				sizeof(strbuf_detectpos), "0.0,0.0,0.0");
			//kv_cped_eid = KvGetNum(kv, "CheckPointDoorID", -2);
			mode_aggressive = KvGetNum(kv, "AggressiveMode", GetConVarInt(h_cv_aggressive_def));
			range_z = KvGetFloat(kv, "DetectZRange", 0.0);
			

#if DEBUG
			LogToFile(logpath, "Loaded settings for this map.");
#endif
		}
		
	}
#if DEBUG	
	else
	{
		LogToFile(logpath, "Failed to load pmc file: %s", pmcpath);
	}
#endif
	ExplodeString(strbuf_detectpos, ",", strbuf_detectpos_exp, 3, 16);
	for (new i=0; i<3; i++)
	{
		TrimString(strbuf_detectpos_exp[i]);
		cpddetectpos[i] = StringToFloat(strbuf_detectpos_exp[i]);
	}
#if DEBUG
	LogToFile(logpath, "Settings for this map: OperationMode: %d, AggressiveMode: %d, DetectZRange: %f",
		opmode, mode_aggressive, range_z);	
	LogToFile(logpath, "Set base position - x: %f, y:%f, z:%f",
			cpddetectpos[0], cpddetectpos[1], cpddetectpos[2]);
#endif
	CloseHandle(kv);
	
	//エディットモードでなければ、ドアのEntityIDを取得しに行く
	if (GetConVarBool(h_cv_edit) != true) GetCPDoorID();
	
	//if kv_cped_eid == 2 means auto detection, other is manual
	/*
	if (kv_cped_eid == -2)
	{
		//Auto detection
		GetCPDoorID();
	}
	else if(IsValidEntity(kv_cped_eid))
	{
		ent_cpd_finish = kv_cped_eid;
		entrancedoorfound = true;
	}
	*/
}

GetCPDoorID()
{
	new ent, count;
	new ent_cpd[8];
	new bool:found = false;
	new Float:finishpos[3], Float:doorpos[8][3], Float:dist, Float:dist_short;
	new String:lmname[32], String:lmname_buf[32];
	
	//Detect CheckPoint(Auto)
	if (opmode == 1)
	{
#if DEBUG
		LogToFile(logpath, "Using landmark detection method.");
#endif
		while ((ent = FindEntityByClassname(ent, "info_changelevel")) != -1)
		{
			GetEntPropString(ent, Prop_Data, "m_landmarkName", lmname, sizeof(lmname));
			//GetEntityNetClass(ent, nclass, sizeof(nclass));
#if DEBUG
			LogToFile(logpath, "Detected info_changelevel ID: %d, LandMarkName: %s", ent, lmname);
#endif
			found = true;
		}
		if (!found)
		{
#if DEBUG
			LogToFile(logpath, "Not found info_changelevel (maybe finale?)");
#endif
			return;
		}
		
		ent = 0; found = false;
		while ((ent = FindEntityByClassname(ent, "info_landmark")) != -1)
		{
			GetEntPropString(ent, Prop_Data, "m_iName", lmname_buf, sizeof(lmname_buf));
#if DEBUG
			LogToFile(logpath, "Detected info_landmark - ID: %d, m_iName: %s", ent, lmname_buf);
#endif			
			if(StrEqual(lmname_buf, lmname))
			{
				GetEntPropVector(ent, Prop_Data,"m_vecAbsOrigin", finishpos);
#if DEBUG
				LogToFile(logpath, "Detected Finish Point - ID: %d, m_iName: %s", ent, lmname_buf);
#endif	
				found = true;
			}
		}
		if (!found)
		{
			#if DEBUG
			LogToFile(logpath, "Not found info_landmark");
			#endif
			return;
		}

		ent = 0; found = false;
		while ((ent = FindEntityByClassname(ent, "prop_door_rotating_checkpoint")) != -1)
		{
			ent_cpd[count] = ent;
			count++;
			#if DEBUG
			LogToFile(logpath, "Detected Check point door - ID: %d", ent);
			#endif
		}

		if (ent_cpd[0] == 0)
		{
			#if DEBUG
			LogToFile(logpath, "Not found CP Door");
			#endif
			return;
		}
		
		for(new i=0; i<8; i++)
		{
			if (ent_cpd[i] != 0 && IsValidEntity(ent_cpd[i]))
			{

				//GetEntPropString(ent_cpd[i], Prop_Data, "m_iName", targetname, sizeof(targetname));
				GetEntPropVector(ent_cpd[i], Prop_Data, "m_vecAbsOrigin", doorpos[i]);
				dist = GetVectorDistance(doorpos[i], finishpos);
#if DEBUG
				LogToFile(logpath, "Calculating Finish CP Door - Index: %d ID: %d, DistFromFinish: %f", i, ent_cpd[i], dist);
#endif					
				if (ent_cpd_finish == -1 || dist < dist_short)
				{
					dist_short = dist;
					ent_cpd_finish = ent_cpd[i];	
					cpdoororigin = doorpos[i];
				}
			}
		}
	}
	else if (opmode == 2)
	{
		//Position based Detection
#if DEBUG
		LogToFile(logpath, "Using position-based detection method.");
#endif
		/*
		new String:strbuf[3][32];
		new Float:basepos[3];
		ExplodeString(basepos_strbuf, ",", strbuf, 3, 32);
		for (new i=0; i<=2; i++)
		{
			TrimString(strbuf[i]);
			basepos[i] = StringToFloat(strbuf[i]);
		}*/

		while ((ent = FindEntityByClassname(ent, "prop_door_rotating_checkpoint")) != -1)
		{
			ent_cpd[count] = ent;
			GetEntPropVector(ent_cpd[count], Prop_Data, "m_vecAbsOrigin", doorpos[count]);
			count++;
#if DEBUG
			LogToFile(logpath, "Detected Check point door - ID: %d", ent);
#endif
		}
		if (ent_cpd[0] == 0)
		{
			#if DEBUG
			LogToFile(logpath, "Not found CP Door");
			#endif
			return;
		}
		
		for (new i=0; i<count; i++)
		{
			dist = GetVectorDistance(cpddetectpos, doorpos[i]);
#if DEBUG
			LogToFile(logpath, "Calculating Finish CP Door - Index: %d ID: %d, DistFromBase: %f", i, ent_cpd[i], dist);
#endif
			if (ent_cpd_finish == -1  || dist < dist_short)
			{
				dist_short = dist;
				ent_cpd_finish = ent_cpd[i];	
				cpdoororigin = doorpos[i];				
			}
		}
	}
	if (ent_cpd_finish >= 0)
	{
		entrancedoorfound = true;
		cpd_speed = GetEntPropFloat(ent_cpd_finish, Prop_Data, "m_flSpeed");
#if DEBUG
		LogToFile(logpath, "Judged Finish CP Door - ID: %d", ent_cpd_finish);
#endif		
	}
}

public Action:AutoDoorLock(Handle:timer)
{
	if(entrancedoorfound == true)
	{
		ChangeDoorLockState(ent_cpd_finish, true);
		if(mode_aggressive == 1) EnableAggressiveMode();
	}
	h_AutoLockTimer = INVALID_HANDLE;
}

ChangeDoorLockState(ent, bool:locked)
{
	if(entrancedoorfound == true)
	{
		if(locked == true)
		{
			SetEntPropFloat(ent, Prop_Data, "m_flSpeed", 200.0);
			AcceptEntityInput(ent, "Close");
			CreateTimer(2.0, SetDoorSpeedZero, ent);
		}
		else
		{
			//AcceptEntityInput(ent, "Open");
			SetDoorSpeedRecv(ent);
		}
		
		//set lockstate flag
		doorlocked = locked;
			
		//DispatchKeyValue(ent,"spawnflags",spawnFlags);
		//Keep door closed
		//spawnpos 0=closed, 1=open clockwise 2=open counter-clockwise 3=Ajar(specified angle)
		//ChangeEdictState(ent);
		//DispatchKeyValue(ent, "distance", "0");
	}
}

public Action:SetDoorSpeedZero(Handle:Timer, any:ent)
{
	SetEntPropFloat(ent, Prop_Data, "m_flSpeed", 0.0);
	// eq DispatchKeyValue(ent, "speed", "0");
	
	//moved to OnClientPutInServer
	//PrintToChatAll("\x03[AntiRunTrap] %t", "saferoom_locked");
}

SetDoorSpeedRecv(ent)
{
	AcceptEntityInput(ent, "Close");
	SetEntPropFloat(ent, Prop_Data, "m_flSpeed", cpd_speed);
	//DispatchKeyValue(ent,"speed","200");
	AcceptEntityInput(ent, "Unlock");
	AcceptEntityInput(ent, "Open");
}

/* AggressiveMode */
EnableAggressiveMode()
{
	if(h_OffsidePollTimer == INVALID_HANDLE)
	{
		h_OffsidePollTimer = CreateTimer(
			float(GetConVarInt(h_cv_aggressive_polling)),
			OffsideCheck,
			_,
			TIMER_REPEAT
		);
	}
}

DisableAggressiveMode()
{
	//cutoff aggressivemode
	if(h_OffsidePollTimer != INVALID_HANDLE)
	{
		KillTimer(h_OffsidePollTimer);
		h_OffsidePollTimer = INVALID_HANDLE;
	}
	if(h_timer_popcitick != INVALID_HANDLE)
	{
		KillTimer(h_timer_popcitick);
		h_timer_popcitick = INVALID_HANDLE;
	}
	if(h_timer_initteleport != INVALID_HANDLE)
	{
		KillTimer(h_timer_initteleport);
		h_timer_initteleport = INVALID_HANDLE;
	}
	if(h_timer_prealartsound != INVALID_HANDLE)
	{
		KillTimer(h_timer_prealartsound);
		h_timer_prealartsound = INVALID_HANDLE;
	}
	if(h_timer_alartsound != INVALID_HANDLE)
	{
		KillTimer(h_timer_alartsound);
		h_timer_alartsound = INVALID_HANDLE;
	}

	for (new i=1; i<=MaxClients; i++) waitingtime[i] = -1;
	activate_ars2 = false;
	activate_ars2_sispawn = false;
}

public Action:Command_EntLock(client, args)
{
	ChangeDoorLockState(ent_cpd_finish, true);
	if(mode_aggressive == 1) EnableAggressiveMode();
	return Plugin_Handled;
}

public Action:Command_EntUnlock(client, args)
{
	DisableAggressiveMode();
	ChangeDoorLockState(ent_cpd_finish, false);
	return Plugin_Handled;
}

public Action:Command_ForceArs2(client, args)
{
	InitTeleport();	
	return Plugin_Handled;
}

public Action:Command_EntCmd2(client, args)
{

	//DispatchKeyValue(ent_cpd_finish,"speed","200");
	//DispatchKeyValue(ent_cpd_finish,"distance","1.0");
	new prop[10], Float:flprop[10];
	
	prop[0] = GetEntProp(ent_cpd_finish, Prop_Data, "m_bLocked");
	flprop[0] = GetEntPropFloat(ent_cpd_finish, Prop_Data, "m_flSpeed");
	prop[2] = GetEntProp(ent_cpd_finish, Prop_Data, "m_eDoorState");
	PrintToChatAll("%d %f %d",prop[0], flprop[0], prop[2]);
	return Plugin_Handled;
}

public Action:PerformBoomerBomb(client, args)
{
	decl Float:targetorg[3], Float:targetangle[3];
	//target = GetClientUserId(client);
	GetClientAbsOrigin(client, targetorg);
	GetClientAbsAngles(client, targetangle);
	targetangle[0] = 60.0;
	if(targetangle[1] >= 0.0){targetangle[1] = -(180.0 - targetangle[1]);}
	else{targetangle[1] = targetangle[1] + 180.0;}
	
	//set the target player cursor to ground & spawn boomer
	TeleportEntity(client, NULL_VECTOR, targetangle, NULL_VECTOR);
	boomerbombticket = 1;
	CreateTimer(1.0, SpawnTicketReset, boomerbombticket);
	ExecCheatCmd(client, "z_spawn", "boomer");
	
	//spawn common xtimes
	if(trigger_ci == false)
	{
		//new String:buffer[255];
		//Format(buffer, sizeof(buffer), "%f %f %f", targetorg[0], targetorg[1], targetorg[2]+30);
		//set spawn range
		spawnpos_pasv[0][0] = targetorg[0]-30.0;
		spawnpos_pasv[0][1] = targetorg[1]+30.0;
		spawnpos_pasv[0][2] = targetorg[2];
		spawnpos_pasv[1][0] = targetorg[0];
		spawnpos_pasv[1][1] = targetorg[1]+30.0;
		spawnpos_pasv[1][2] = targetorg[2];
		spawnpos_pasv[2][0] = targetorg[0]+30.0;
		spawnpos_pasv[2][1] = targetorg[1]+30.0;
		spawnpos_pasv[2][2] = targetorg[2];
		spawnpos_pasv[3][0] = targetorg[0]-30.0;
		spawnpos_pasv[3][1] = targetorg[1];
		spawnpos_pasv[3][2] = targetorg[2];
		spawnpos_pasv[4][0] = targetorg[0]+30.0;
		spawnpos_pasv[4][1] = targetorg[1];
		spawnpos_pasv[4][2] = targetorg[2];
		spawnpos_pasv[5][0] = targetorg[0]-30.0;
		spawnpos_pasv[5][1] = targetorg[1]-30.0;
		spawnpos_pasv[5][2] = targetorg[2];
		spawnpos_pasv[6][0] = targetorg[0];
		spawnpos_pasv[6][1] = targetorg[1]-30.0;
		spawnpos_pasv[6][2] = targetorg[2];
		spawnpos_pasv[7][0] = targetorg[0]+30.0;
		spawnpos_pasv[7][1] = targetorg[1]-30.0;
		spawnpos_pasv[7][2] = targetorg[2];
		
		trigger_ci = true;
		/*
		new flags_spawn = GetCommandFlags("z_spawn");
		SetCommandFlags("z_spawn", flags_spawn & ~FCVAR_CHEAT);
		for(new i=0; i<30; i++)
		{
			targetangle[1] = i * 10.0;
			if(targetangle[1] > 180.0) targetangle[1] -= 360.0;
			TeleportEntity(client, NULL_VECTOR, targetangle, NULL_VECTOR);
			FakeClientCommand(client, "z_spawn common");
		}
		SetCommandFlags("z_spawn", flags_spawn);
		
		*/
		if (h_timer_popcitick == INVALID_HANDLE)
			h_timer_popcitick = CreateTimer(0.1, PopCITick, client, TIMER_REPEAT);
		CreateTimer(10.0, ReturnTriggerCI);
	}
	
	return Plugin_Handled;
}

public Action:PopCITick(Handle:timer, any:client)
{
	if(count_cipop < 30)
	{
		ExecCheatCmd(client, "z_spawn", "common");
		count_cipop++;
	}
	else
	{
		KillTimer(h_timer_popcitick);
		h_timer_popcitick = INVALID_HANDLE;
		count_cipop = 0;
	}
}

public Action:SpawnTicketReset(Handle:timer, any:ticket)
{
	ticket = 0;
}

ExecCheatCmd(client, String:command[], String:arg1[])
{
	new flags = GetCommandFlags(command);
	SetCommandFlags(command, flags & ~FCVAR_CHEAT);
	FakeClientCommand(client, "%s %s", command, arg1);
	SetCommandFlags(command, flags);
}

public Action:Command_ForceSetId(client, args)
{
	new entityid, String:arg1[32];
	if(args >= 1)
	{
		GetCmdArg(1, arg1, sizeof(arg1));
		entityid = StringToInt(arg1);
		if(IsValidEntity(entityid))
		{
			PrintToConsole(client, "Set entity id.");
			ent_cpd_finish = entityid;
			cpd_speed = GetEntPropFloat(ent_cpd_finish, Prop_Data, "m_flSpeed");
			entrancedoorfound = true;
		}
		else
		{
			PrintToConsole(client, "Invalid entity id.");
		}
	}
	return Plugin_Handled;
}

public Action:Command_PluginStatus(client, args)
{
	//[todo]ちょっと整理したい
	
	decl String:gotdoor[32];
	/*
	if(kv_cped_eid == -2)
	{
		if(entrancedoorfound == true) gotdoor = "Yes(Auto)";
		else gotdoor = "No(Auto)";
	}
	if(kv_cped_eid == -1) gotdoor = "Disabled";
	if(kv_cped_eid >= 0){
		if(entrancedoorfound == true) gotdoor = "Yes(Manual)";
		else gotdoor = "No(Manual)";
	}
	*/
	ReplyToCommand(client, "Mapname: %s", mapname);
	ReplyToCommand(client, "----- Settings -----");
	//ReplyToCommand(client, "CheckPointDoorID: %d", kv_cped_eid);
	ReplyToCommand(client, "aggressiveMode: %d", mode_aggressive);
	ReplyToCommand(client, "DetectZRange: %f", range_z);
	ReplyToCommand(client, "----- Status -----");
	ReplyToCommand(client, "RoundStart_Trigger = %d", trigger_rs);
	//ReplyToCommand(client, "Got Entity ID of Saferoom door = %s", gotdoor);
	ReplyToCommand(client, "Currently Controlling Entity ID = %d", ent_cpd_finish);
	ReplyToCommand(client, "Saferoom Door Locked = %d", doorlocked);

	ReplyToCommand(client, "Detecting info_changelevel...");
	decl String:targetname[255];

	new Float:finishpos[3], Float:doorpos[3], Float:dist;
	new ent;
	new detect1 = -1;
	new String:lmname[32], String:lmname_buf[32];
	while ((ent = FindEntityByClassname(ent, "info_changelevel")) != -1)
	{
		GetEntPropString(ent, Prop_Data, "m_landmarkName", lmname, sizeof(lmname));
		//GetEntityNetClass(ent, nclass, sizeof(nclass));
		ReplyToCommand(client, "ID: %d, LandMarkName: %s", ent, lmname);	
		detect1 = ent;
	}
	if (detect1 == -1) ReplyToCommand(client, "Not found.");
	else
	{
		ReplyToCommand(client, "Detecting info_landmark %s...", lmname);
		while ((ent = FindEntityByClassname(ent, "info_landmark")) != -1)
		{
			GetEntPropString(ent, Prop_Data, "m_iName", lmname_buf, sizeof(lmname_buf));
			if(StrEqual(lmname_buf, lmname))
			{
				ReplyToCommand(client, "Found %s, ID: %d", lmname, ent);
				GetEntPropVector(ent, Prop_Data,"m_vecAbsOrigin", finishpos);	
			}
		}
	}
	ReplyToCommand(client, "Found Saferoom door entites:");
	while ((ent = FindEntityByClassname(ent, "prop_door_rotating_checkpoint")) != -1)
	{
		GetEntPropString(ent, Prop_Data,"m_iName",targetname,sizeof(targetname));
		GetEntPropVector(ent, Prop_Data,"m_vecAbsOrigin", doorpos);
		dist = GetVectorDistance(finishpos, doorpos);
		ReplyToCommand(client, "ID: %d, Name: %s, DistFromFinish: %d Pos: %f %f %f",
			ent, targetname, RoundFloat(dist), doorpos[0], doorpos[1], doorpos[2]);
	}
	
	return Plugin_Handled;
}

public Action:Command_SetDetectPos(client, args)
{
	new ent;
	new ent_nearest = -1;
	new Float:doorpos[3], Float:dist, Float:dist_nearest;
	new String:targetname[32];
	if (client <= 0)
	{
		ReplyToCommand(client, "This command is in-game only.");
		return Plugin_Handled;
	}
	
	if (!IsEnabledEditMode(client)) return Plugin_Handled;
	
	GetClientAbsOrigin(client, cpddetectpos);
	ReplyToCommand(client, "Set detect position to here: %f, %f, %f", cpddetectpos[0], cpddetectpos[1], cpddetectpos[2]);
	//set to position-based mode
	opmode = 2;
	ent_cpd_finish = -1;
	while ((ent = FindEntityByClassname(ent, "prop_door_rotating_checkpoint")) != -1)
	{
		GetEntPropString(ent, Prop_Data,"m_iName",targetname,sizeof(targetname));
		GetEntPropVector(ent, Prop_Data,"m_vecAbsOrigin", doorpos);
		dist = GetVectorDistance(cpddetectpos, doorpos);
		ReplyToCommand(client, "ID: %d, Name: %s, DistFromDetectPos: %d Pos: %f %f %f",
			ent, targetname, RoundFloat(dist), doorpos[0], doorpos[1], doorpos[2]);
		if (ent_cpd_finish == -1 || dist < dist_nearest)
		{
			dist_nearest = dist;
			ent_cpd_finish = ent;
		}
	}
	
	if (ent_cpd_finish != -1)
	{
		entrancedoorfound = true;
		GetEntPropVector(ent_cpd_finish, Prop_Data,"m_vecAbsOrigin", cpdoororigin);
		ReplyToCommand(client, "The nearest door id is %d.", ent_cpd_finish);
		SetEntProp(ent_cpd_finish, Prop_Send, "m_iGlowType", 0);
		ReplyToCommand(client, "To use this setting, You need to write current settings to settings file.");
		ReplyToCommand(client, "If you want to write detect position setting, type \"l4d_antirun_edit_save\".");
		ReplyToCommand(client, "To retry to set detect position, retype this command.");
	}
	else
	{
		ReplyToCommand(client, "Checkpoint door not found.");		
	}
	
	return Plugin_Handled;
	
}

public Action:Command_SaveSettings(client, args)
{
	//init
/*
	ent_cpd_finish = -1;
	mode_aggressive = GetConVarInt(h_cv_aggressive_def);
	range_z = 0.0;
	decl String:strbuf_detectpos[64];
	decl String:strbuf_detectpos_exp[3][16];
	entrancedoorfound = false;
*/
	new String:str_vec[3][16], String:wbuf_vec[64];

	if (client <= 0)
	{
		ReplyToCommand(client, "This command is in-game only.");
		return Plugin_Handled;
	}
	
	if (!IsEnabledEditMode(client)) return Plugin_Handled;
	
	new Handle:kv = CreateKeyValues("PerMapConfig");

	//Load settings per map
	if (FileToKeyValues(kv, pmcpath))
	{
		if (KvJumpToKey(kv, mapname, true))
		{
			for (new i=0; i<3; i++) FloatToString(cpddetectpos[i], str_vec[i], sizeof(str_vec[]));
			ImplodeStrings(str_vec, 3, ",", wbuf_vec, sizeof(wbuf_vec));

			KvSetString(kv, "CPDoorDetectPos", wbuf_vec);
			KvSetNum(kv, "OperationMode", opmode);
			KvSetNum(kv, "AggressiveMode", mode_aggressive);
			KvSetFloat(kv, "DetectZRange", range_z);
			KvRewind(kv);
			if (KeyValuesToFile(kv, pmcpath))
			{
				ReplyToCommand(client, "Wrote settings to file \"%s\".", pmcpath);		
			}
			else
			{
				ReplyToCommand(client, "Error: Failed to write per-map settings file \"%s\".", pmcpath);	
			}

		}
	}
	else
	{
		//ファイルが空とかでもここになるらしい
		ReplyToCommand(client, "Error: Failed to write per-map settings file \"%s\".", pmcpath);
	}
	
	CloseHandle(kv);
	return Plugin_Handled;
}

public Action:Command_ErasePosition(client, args)
{
	new String:str_vec[3][16], String:wbuf_vec[64];

	if (client <= 0)
	{
		ReplyToCommand(client, "This command is in-game only.");
		return Plugin_Handled;
	}
	
	if (!IsEnabledEditMode(client)) return Plugin_Handled;
	
	new Handle:kv = CreateKeyValues("PerMapConfig");

	//Load settings per map
	if (FileToKeyValues(kv, pmcpath))
	{
		if (KvJumpToKey(kv, mapname, true))
		{
			new bool:result = KvDeleteKey(kv, "CPDoorDetectPos");
			//check result
			if (result == true)
			{
				//set auto detection and rewind keyvalues
				KvSetNum(kv, "OperationMode", 1);
				KvRewind(kv);
				//if key has exist, write file.
				if (KeyValuesToFile(kv, pmcpath))
				{
					ReplyToCommand(client, "Eresed position in per-map config file \"%s\".", pmcpath);		
				}
				else
				{
					ReplyToCommand(client, "Error: Failed to write per-map config file \"%s\".", pmcpath);	
				}
			}
		}
	}
	else
	{
		ReplyToCommand(client, "Error: Failed to write per-map config file \"%s\".", pmcpath);
	}
	
	CloseHandle(kv);
	return Plugin_Handled;
}

bool:IsEnabledEditMode(client)
{
	new bool:value = GetConVarBool(h_cv_edit);
	if (value == false)
		ReplyToCommand(client, "Edit mode is disabled now. To enable this, type \"l4d_antirun_edit 1\".");
	
	return value;
}

public Action:Command_CheckDistance(client, args)
{
	if (!IsEnabledEditMode(client)) return Plugin_Handled;
	new Float:vec_client[3], Float:vec_cpd[3], Float:dist, Float:dist_m, Float:dist_z;
	if (entrancedoorfound == true)
	{
		GetClientAbsOrigin(client, vec_client);
		GetEntPropVector(ent_cpd_finish, Prop_Data, "m_vecAbsOrigin", vec_cpd);
		dist = GetVectorDistance(vec_client, vec_cpd);
		dist_m = dist*0.01905;
		dist_z = FloatAbs(cpdoororigin[2] - (vec_client[2] + 50.0));
		ReplyToCommand(client, "Distance = %f (%f m), Z-Distance = %f", dist, dist_m, dist_z);
	}
	else
	{
		ReplyToCommand(client, "Checkpoint is not configured!");
	}
	
	return Plugin_Handled;
}

public Action:Command_SetValue(client, args)
{
	if (!IsEnabledEditMode(client)) return Plugin_Handled;
	
	new argcount = GetCmdArgs();
	decl String:str_arg[32], String:str_value[32];
	
	if (argcount == 0)
	{
		ReplyToCommand(client, "usage: l4d_antirun_editval <key> <value> [<key> <value>] ...");
		return Plugin_Handled;
	}	
	else if (argcount % 2 != 0)
	{
		ReplyToCommand(client, "argument format is wrong");
		return Plugin_Handled;
	}
	for (new i=1; i<=argcount; i=i+2)
	{
		GetCmdArg(i, str_arg, sizeof(str_arg));
		GetCmdArg(i+1, str_value, sizeof(str_value));
		if (StrEqual(str_arg, "-operation", false))
		{
			opmode = StringToInt(str_value);
		}
		else if (StrEqual(str_arg, "-aggressive", false))
		{
			mode_aggressive = StringToInt(str_value);
		}
		else if (StrEqual(str_arg, "-z_range", false))
		{
			range_z = StringToFloat(str_value);
		}
		else
		{
			ReplyToCommand(client, "Invalid argument: %s", str_arg);
			break;
		}
	}
	return Plugin_Handled;
}

public Action:Command_ReloadConfig(client, args)
{
	if (!IsEnabledEditMode(client)) return Plugin_Handled;
	LoadPerMapConfig();
	ReplyToCommand(client, "Config reloaded from pmc file.");
	return Plugin_Handled;
}

public Action:Command_ShowConfig(client, args)
{
	ReplyToCommand(client, "----- Current Config -----");
	
	ReplyValueInt(client, "Operation Mode", opmode);
	ReplyBool(client, "Aggressive Mode", mode_aggressive);
	//ReplyToCommand(client, "Operation Mode: %d", opmode);
	//ReplyToCommand(client, "Aggressive Mode: %d", mode_aggressive);
	ReplyToCommand(client, "Detect Position: %f, %f, %f", cpddetectpos[0], cpddetectpos[1], cpddetectpos[2]);
	ReplyValueFloat(client, "Z-Axis Range", range_z);
	//ReplyToCommand(client, "Z-Axis Range: %f", range_z);
	return Plugin_Handled;
}

ReplyBool(client, String:title[], value)
{
	if (value) PrintKVShaped(client, title, "Yes");
	else PrintKVShaped(client, title, "No");
	return;
}

ReplyValueInt(client, String:title[], value)
{
	decl String:str_val[16];
	IntToString(value, str_val, sizeof(str_val));
	PrintKVShaped(client, title, str_val);
	return;
}

ReplyValueFloat(client, String:title[], Float:value)
{
	decl String:str_val[16];
	FloatToString(value, str_val, sizeof(str_val));
	PrintKVShaped(client, title, str_val);
	return;
}

PrintKVShaped(client, String:key[], String:value[])
{
	decl String:buffer[128], String:buffer_val[64];
	new buffer_length;
	if (strlen(key) > 64)
	{
		strcopy(buffer, 61, key);
		StrCat(buffer, sizeof(buffer), "...");
	}
	else
	{
		strcopy(buffer, sizeof(buffer), key);
		for (new i=strlen(buffer); i<64; i++)
			StrCat(buffer, sizeof(buffer), " ");
	}
	StrCat(buffer, sizeof(buffer), " : ");
	strcopy(buffer_val, sizeof(buffer_val), value);
	if (strlen(buffer_val) < 8)
	{
		for(new i=strlen(buffer_val); i<8; i++)
			StrCat(buffer, sizeof(buffer), " ");
		
	}
	StrCat(buffer, sizeof(buffer), buffer_val);
	ReplyToCommand(client, "%s", buffer);
	return;
}